<template>
  <div>
    <div
      class="d-flex flex-column align-items-center justify-content-center min-vh100 p-2"
    >
      <img
        alt="Citadel"
        src="@/assets/logo.svg"
        height="200"
        class="mb-2 logo"
      />
      <h1 class="text-center mb-2">{{ heading }}</h1>
      <p class="text-muted w-75 text-center">{{ text }}</p>

      <div
        class="form-container mt-3 d-flex flex-column form-container w-100 align-items-center"
      >
        <b-form-input
          v-show="currentStep === 1"
          v-model="name"
          placeholder="Your name"
          class="card-input w-100"
          autofocus
        ></b-form-input>

        <input-password
          v-show="currentStep === 2"
          v-model="password"
          placeholder="Your password"
          input-class="card-input w-100"
          autocomplete="new-password"
        />

        <input-password
          v-show="currentStep === 3"
          v-model="confirmPassword"
          placeholder="Re-enter your password"
          input-class="card-input w-100"
          autocomplete="new-password"
        />

        <div v-if="currentStep == 4" class="row gap-3" style="width: 95vw">
          <card-widget
            title="Bitcoin Core"
            icon="icon-app-bitcoin.svg"
            class="col pt-4"
          >
            <div class="d-flex w-100 flex-column px-3 px-lg-4 pb-4">
              <h4>The "original"</h4>
              Bitcoin Core is the "original" Bitcoin client, and is the
              "standard" for running a full node.
              <b-button
                variant="success"
                size="lg"
                class="mt-4 mx-auto d-block px-4"
                :disabled="!isKnots"
                @click="setBitcoinClient('core')"
                >{{ isKnots ? "Select" : "Selected" }}</b-button
              >
            </div>
          </card-widget>
          <card-widget
            title="Bitcoin Knots"
            icon="icon-app-bitcoin-knots.svg"
            class="col pt-4"
          >
            <div class="d-flex w-100 flex-column px-3 px-lg-4 pb-4">
              <h4>The better</h4>
              Bitcoin Knots is a fork of Bitcoin Core with a collection of
              improvements. For example, it can deal with data corruption better
              and is faster. It is 100% compatible with Bitcoin Core, and on
              Citadel, has no differences in the default configuration. It is
              the default and recommended Bitcoin client for Citadel.
              <b-button
                variant="success"
                size="lg"
                class="mt-3 mx-auto d-block px-4"
                :disabled="isKnots"
                @click="setBitcoinClient('knots')"
                >{{ isKnots ? "Selected" : "Select" }}</b-button
              >
            </div>
          </card-widget>
        </div>

        <div v-if="currentStep === 6">
          <seed
            v-show="userStore.seed.length && !isRegistering"
            :words="userStore.seed"
            :recover="recover"
            @complete="finishedSeed"
            @incomplete="incompleteRecoverySeed"
            @input="inputRecoverySeed"
          />
          <b-spinner
            v-show="!userStore.seed.length || isRegistering"
          ></b-spinner>
        </div>

        <input-copy
          v-if="currentStep === 7"
          class="w-100"
          size="sm"
          :value="systemStore.onionAddress"
        ></input-copy>

        <div v-show="currentStep === 8">
          <div class="text-center bg-secondary p-3 rounded">
            <small class="d-block text-muted text-small text-center mb-3"
              >By clicking next, I agree that:</small
            >
            <span class="d-block text-muted text-small mb-1">
              <b-icon-exclamation-circle-fill
                variant="warning"
                class="me-1"
              />Citadel is in beta and should not be considered secure
            </span>
            <span class="d-block text-muted text-small mb-1">
              <b-icon-exclamation-circle-fill variant="warning" class="me-1" />I
              should not put more funds on my Citadel than I'm prepared to lose
            </span>
          </div>
        </div>

        <div v-show="currentStep === 9" class="text-center">
          <p class="text-muted">
            But you don't have to wait for the sync to complete... You can start
            using Citadel right away!
          </p>
          <a
            v-tooltip.bottom="
              'Citadel uses neutrino while the sync is in progress, and automatically switches to Bitcoin Core once it\'s synced'
            "
            href="#"
          >
            <small>
              <b-icon-exclamation-circle-fill
                icon="exclamation-circle-fill"
                variant="primary"
                class="me-1"
              />How?
            </small>
          </a>
        </div>

        <b-button
          variant="success"
          size="lg"
          :disabled="
            !isStepValid || isRegistering || !lightningStore.operational
          "
          class="mt-3 mx-auto d-block px-4"
          :class="{
            'loading-fade-blink':
              !lightningStore.operational ||
              (currentStep === 9 && !lightningStore.unlocked),
            invisible: currentStep === 6 && recover && !isStepValid,
          }"
          @click="nextStep"
          >{{
            !lightningStore.operational ? "Loading" : nextButtonText
          }}</b-button
        >
        <b-button
          v-if="currentStep === 5 || (currentStep === 6 && !recover)"
          variant="link"
          size="sm"
          class="mt-3 mx-auto d-block"
          :disabled="isRegistering"
          @click="skipSeed"
          >Note Down Later</b-button
        >
        <b-button
          v-if="currentStep === 5"
          variant="link"
          size="sm"
          class="mt-2 mx-auto d-block"
          @click="recoverFromSeed"
          >Recover</b-button
        >
        <b-button
          v-if="currentStep > 0 && currentStep !== 7 && currentStep !== 9"
          variant="link"
          size="sm"
          class="mt-2 mx-auto d-block text-dark"
          @click="prevStep"
          >Back</b-button
        >
      </div>
      <b-progress
        :value="progress"
        height="1rem"
        class="onboarding-progress"
      ></b-progress>
    </div>
  </div>
</template>

<script lang="ts" setup>
/* eslint-disable */
import useSystemStore from "@/store/system";
import useUserStore from "@/store/user";
import useLightningStore from "@/store/lightning";
import useToast from "@/utils/toast";
import { useI18n } from "vue-i18n";
import InputPassword from "@/components/Utility/InputPassword.vue";
import InputCopy from "@/components/Utility/InputCopy.vue";
import Seed from "@/components/Utility/Seed.vue";
import { BIconExclamationCircleFill } from "bootstrap-icons-vue";
import useBitcoinStore from "~/store/bitcoin";

const systemStore = useSystemStore();
const userStore = useUserStore();
const lightningStore = useLightningStore();
const bitcoinStore = useBitcoinStore();
const toast = useToast();
const { t } = useI18n();

const name = ref("");
const password = ref("");
const confirmPassword = ref("");
const currentStep = ref(0);
const notedSeed = ref(false);
const isRegistering = ref(false);
const recover = ref(false);
const recoverySeed = ref<string[]>([]);
const lndUnlockInterval = ref<number | undefined>(undefined);

const heading = computed(() => {
  if (currentStep.value === 6 && recover.value) {
    return "recover your citadel";
  }
  return t(`setup.step-${currentStep.value + 1}.heading`);
});
const text = computed(() => {
  if (currentStep.value === 6 && recover.value) {
    return "Enter your 24 secret words in the exact order to recover your Citadel.";
  }
  return t(`setup.step-${currentStep.value + 1}.text`);
});
const nextButtonText = computed(() => {
  if (currentStep.value === 0) {
    return "Start";
  }
  if (currentStep.value === 9) {
    return "Go to dashboard";
  }
  return "Next";
});
const isStepValid = computed(() => {
  if (currentStep.value === 1) {
    return name.value.length > 0;
  }

  if (currentStep.value === 2) {
    return password.value.length > 11;
  }

  if (currentStep.value === 3) {
    if (confirmPassword.value !== password.value) {
      return false;
    }
  }

  if (currentStep.value === 6) {
    return notedSeed.value;
  }

  if (currentStep.value === 9) {
    return lightningStore.unlocked;
  }

  return true;
});
const progress = computed(() => {
  return currentStep.value === 0
    ? 0
    : Math.round((currentStep.value * 100) / 9);
});

const isKnots = ref(false);

async function setBitcoinClient(client: "core" | "knots") {
  await useCitadel().bitcoin.setImpl(client);
  isKnots.value = client === "knots";
}

onMounted(async () => {
  //redirect to home if the user is already registered
  if (userStore.registered) {
    return await navigateTo("/");
  }
  
  await bitcoinStore.getVersion();
  isKnots.value = bitcoinStore.version.includes("Knots");

  // Wait for LND
  while (!lightningStore.operational) {
    await lightningStore.getStatus();
    await delay(1000);
  }

  //generate a new seed on load
  userStore.getSeed();
});
onBeforeUnmount(() => {
  window.clearInterval(lndUnlockInterval.value);
});
function skipSeed(): void {
  if (currentStep.value === 5) {
    currentStep.value = 6;
  }
  nextStep();
}
function recoverFromSeed() {
  recover.value = true;
  currentStep.value++;
}
function inputRecoverySeed(seed: string[]) {
  recoverySeed.value = seed;
}
async function nextStep() {
  if (currentStep.value === 5) {
    recover.value = false;
  }

  //Register user and initialize wallet at the end
  if (currentStep.value === 6) {
    isRegistering.value = true;
    const seed = recover.value ? recoverySeed.value : userStore.seed;
    try {
      await userStore.register({
        name: name.value,
        password: password.value,
        seed,
      });
    } catch (error) {
      isRegistering.value = false;
      if (error) {
        toast.error("Error", JSON.stringify(error));
      }
      return;
    }

    isRegistering.value = false;

    // fetch onion address for the next step
    systemStore.getOnionAddress();
  }

  if (currentStep.value === 8) {
    //Wohoo! Time to celebrate!
    /*this.$confetti.start({
          particles: [
            {
              type: "rect",
            },
          ],
        });*/

    lndUnlockInterval.value = window.setInterval(async () => {
      lightningStore.getStatus();
      if (lightningStore.unlocked) {
        return window.clearInterval(lndUnlockInterval.value);
      }
    }, 1000);

    // TODO: Find the root problem and fix it
    // Refresh page after 60s if LND still hasn't unlocked
    window.setTimeout(() => {
      if (!lightningStore.unlocked) {
        window.location.reload();
      }
    }, 60 * 1000);

    //Ok. 3s is more than enough to celebrate.
    /*window.setTimeout(() => {
          this.$confetti.stop();
        }, 3000);*/
  }

  if (currentStep.value === 9) {
    return navigateTo("/dashboard");
  }

  return (currentStep.value = currentStep.value + 1);
}
function prevStep() {
  if (currentStep.value === 6) {
    notedSeed.value = false;
  }

  currentStep.value = currentStep.value - 1;
}
function finishedSeed() {
  notedSeed.value = true;
}
function incompleteRecoverySeed() {
  notedSeed.value = false;
}
</script>

<style lang="scss" scoped>
.logo {
  height: 20vh;
  max-height: 200px;
  width: auto;
}
.form-container {
  max-width: 500px;
}
.onboarding-progress {
  position: absolute;
  width: 100%;
  top: 0;
  left: 0;
  border-radius: 0;
  background: transparent;
}
.loading-fade-blink {
  animation: loadingFadeBlink 1s infinite linear;
}

@keyframes loadingFadeBlink {
  0%,
  100% {
    opacity: 0.6;
  }
  50% {
    opacity: 0.3;
  }
}
</style>
